function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
var _excluded = ["portal", "type", "maskProps", "icon", "iconProps", "captionProps", "content", "children"],
  _excluded2 = ["caption"];
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React, { forwardRef, useRef, useImperativeHandle } from 'react';
import { createPortal } from 'react-dom';
// 测试使用
// import { locale } from 'seedsui-react'
// 内库使用
import locale from "./../locale"; // 国际化数据
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
var Loading = /*#__PURE__*/forwardRef(function (_ref, ref) {
  var portal = _ref.portal,
    _ref$type = _ref.type,
    type = _ref$type === void 0 ? 'floating' : _ref$type,
    _ref$maskProps = _ref.maskProps,
    maskProps = _ref$maskProps === void 0 ? {} : _ref$maskProps,
    icon = _ref.icon,
    iconProps = _ref.iconProps,
    _ref$captionProps = _ref.captionProps,
    captionProps = _ref$captionProps === void 0 ? {} : _ref$captionProps,
    content = _ref.content,
    children = _ref.children,
    props = _objectWithoutProperties(_ref, _excluded);
  var rootRef = useRef(null);
  var containerRef = useRef(null);
  useImperativeHandle(ref, function () {
    return {
      rootDOM: rootRef.current,
      containerDOM: containerRef.current,
      getRootDOM: function getRootDOM() {
        return rootRef.current;
      },
      getContainerDOM: function getContainerDOM() {
        return containerRef.current;
      }
    };
  });
  var _captionProps$caption = captionProps.caption,
    caption = _captionProps$caption === void 0 ? locale('加载中...', 'loading') : _captionProps$caption,
    otherCaptionProps = _objectWithoutProperties(captionProps, _excluded2);
  if (typeof content === 'string') {
    caption = content;
  }
  var contentNode = null;
  if (type === 'custom') {
    // 自定义样式
    contentNode = /*#__PURE__*/_jsxs("div", _objectSpread(_objectSpread({
      ref: containerRef
    }, props), {}, {
      className: "loading-custom".concat(props.className ? ' ' + props.className : ''),
      children: [icon && icon, iconProps && /*#__PURE__*/_jsx("span", _objectSpread(_objectSpread({}, iconProps), {}, {
        className: "loading-custom-icon".concat(iconProps.className ? ' ' + iconProps.className : '')
      })), caption && /*#__PURE__*/_jsx("p", _objectSpread(_objectSpread({}, otherCaptionProps), {}, {
        className: "loading-custom-caption".concat(otherCaptionProps.className ? ' ' + otherCaptionProps.className : ''),
        children: caption
      }))]
    }));
  } else if (type === 'filling') {
    // 填料环
    contentNode = /*#__PURE__*/_jsx("div", _objectSpread(_objectSpread({
      ref: containerRef
    }, props), {}, {
      className: "loading-filling active".concat(props.className ? ' ' + props.className : ''),
      children: /*#__PURE__*/_jsx("div", {
        className: "loading-filling-icon"
      })
    }));
  } else if (type === 'floating') {
    // 流光
    contentNode = /*#__PURE__*/_jsxs("div", _objectSpread(_objectSpread({
      ref: containerRef
    }, props), {}, {
      className: "loading-floating animated".concat(props.className ? ' ' + props.className : ''),
      children: [/*#__PURE__*/_jsxs("div", {
        className: "loading-floating-icon",
        children: [/*#__PURE__*/_jsx("div", {
          className: "loading-floating-blade"
        }), /*#__PURE__*/_jsx("div", {
          className: "loading-floating-blade"
        }), /*#__PURE__*/_jsx("div", {
          className: "loading-floating-blade"
        }), /*#__PURE__*/_jsx("div", {
          className: "loading-floating-blade"
        }), /*#__PURE__*/_jsx("div", {
          className: "loading-floating-blade"
        }), /*#__PURE__*/_jsx("div", {
          className: "loading-floating-blade"
        }), /*#__PURE__*/_jsx("div", {
          className: "loading-floating-blade"
        }), /*#__PURE__*/_jsx("div", {
          className: "loading-floating-blade"
        }), /*#__PURE__*/_jsx("div", {
          className: "loading-floating-blade"
        }), /*#__PURE__*/_jsx("div", {
          className: "loading-floating-blade"
        }), /*#__PURE__*/_jsx("div", {
          className: "loading-floating-blade"
        }), /*#__PURE__*/_jsx("div", {
          className: "loading-floating-blade"
        })]
      }), caption && /*#__PURE__*/_jsx("div", _objectSpread(_objectSpread({}, otherCaptionProps), {}, {
        className: "loading-floating-caption".concat(otherCaptionProps.className ? ' ' + otherCaptionProps.className : ''),
        children: caption
      }))]
    }));
  }

  // 组合Node
  var Node = /*#__PURE__*/_jsxs("div", _objectSpread(_objectSpread({}, maskProps), {}, {
    className: 'loading-mask mask active' + (maskProps.className ? ' ' + maskProps.className : ''),
    ref: rootRef,
    children: [contentNode, children]
  }));
  if (portal) {
    return /*#__PURE__*/createPortal(Node, portal);
  }
  return Node;
});
export default Loading;