import locale from "./../locale";

// 显示Loading
// eslint-disable-next-line
export default function (props) {
  var _ref = props || {},
    id = _ref.id,
    maskProps = _ref.maskProps,
    captionProps = _ref.captionProps,
    className = _ref.className,
    style = _ref.style,
    content = _ref.content,
    onVisibleChange = _ref.onVisibleChange;
  // 渲染
  function render() {
    var loadingId = id || '__SeedsUI_loading_el__';
    // 如果没生成成功, 则强制生成
    var loadingDOM = document.getElementById(loadingId);
    if (!loadingDOM) {
      loadingDOM = document.createElement('div');
      loadingDOM.innerHTML = "<div class=\"loading-container\">\n          <div class=\"loading-floating-icon\">\n            <div class=\"loading-floating-blade\"></div>\n            <div class=\"loading-floating-blade\"></div>\n            <div class=\"loading-floating-blade\"></div>\n            <div class=\"loading-floating-blade\"></div>\n            <div class=\"loading-floating-blade\"></div>\n            <div class=\"loading-floating-blade\"></div>\n            <div class=\"loading-floating-blade\"></div>\n            <div class=\"loading-floating-blade\"></div>\n            <div class=\"loading-floating-blade\"></div>\n            <div class=\"loading-floating-blade\"></div>\n            <div class=\"loading-floating-blade\"></div>\n            <div class=\"loading-floating-blade\"></div>\n          </div>\n          <div class=\"loading-floating-caption loading-content\"></div>\n        </div>"
      // 添加到dom上
      ;
      (document.getElementById('root') || document.body).appendChild(loadingDOM);
    }

    // 更新dom
    loadingDOM.setAttribute('class', "loading-mask mask active".concat(maskProps !== null && maskProps !== void 0 && maskProps.className ? ' ' + (maskProps === null || maskProps === void 0 ? void 0 : maskProps.className) : ''));
    loadingDOM.setAttribute('id', loadingId);
    for (var key in (maskProps === null || maskProps === void 0 ? void 0 : maskProps.style) || {}) {
      loadingDOM.style[key] = maskProps === null || maskProps === void 0 ? void 0 : maskProps.style[key];
    }
    var container = loadingDOM.querySelector('.loading-container');
    if (container) {
      container === null || container === void 0 ? void 0 : container.setAttribute('class', "loading-container loading-floating animated".concat(className ? ' ' + className : ''));
      for (var _key in style || {}) {
        container.style[_key] = style[_key];
      }
    }
    var caption = (captionProps === null || captionProps === void 0 ? void 0 : captionProps.caption) || content;
    caption = typeof caption === 'string' ? caption : locale('加载中...', 'loading');
    loadingDOM.querySelector('.loading-content').innerHTML = caption;

    // 显示
    loadingDOM.classList.add('active');
    if (typeof onVisibleChange === 'function') {
      onVisibleChange(true);
    }
  }
  render();
}