function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
var _excluded = ["ak", "show", "portal", "title", "prevTitle", "onHide", "center", "points", "circle", "polygon", "district", "header", "children"];
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0); } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i.return && (_r = _i.return(), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React, { useRef, useContext, useEffect, useState } from 'react';
import { createPortal } from 'react-dom';
import MapUtil from "./../MapUtil";
import Page from "./../Page";
import Header from "./../Header";
import Container from "./../Container";
import Notice from "./../Notice";
import Bridge from "./../Bridge";
import Wrapper from "./Wrapper";
import Close from "./Close";
import MapInstance from "./MapInstance";
import Context from "./../Context/instance.js";
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
function MapView(_ref) {
  var ak = _ref.ak,
    _ref$show = _ref.show,
    show = _ref$show === void 0 ? true : _ref$show,
    portal = _ref.portal,
    title = _ref.title,
    prevTitle = _ref.prevTitle,
    onHide = _ref.onHide,
    _ref$center = _ref.center,
    center = _ref$center === void 0 ? '江苏省,南京市' : _ref$center,
    points = _ref.points,
    circle = _ref.circle,
    polygon = _ref.polygon,
    district = _ref.district,
    header = _ref.header,
    children = _ref.children,
    others = _objectWithoutProperties(_ref, _excluded);
  var _useState = useState(null),
    _useState2 = _slicedToArray(_useState, 2),
    mapInstance = _useState2[0],
    setMapInstance = _useState2[1];
  // context
  var context = useContext(Context) || {};
  var locale = context.locale || function (remark) {
    return remark || '';
  };
  var refWrapperEl = useRef(null);
  var _useState3 = useState(''),
    _useState4 = _slicedToArray(_useState3, 2),
    errMsg = _useState4[0],
    setErrMsg = _useState4[1];
  useEffect(function () {
    if (!window.BMap && !ak) {
      setErrMsg(locale('请传入百度地图ak', 'hint_map_ak'));
      return;
    }
    MapUtil.load({
      ak: ak,
      success: function success() {
        initData();
      },
      fail: function fail() {
        setErrMsg(locale('地图库加载失败, 请稍后再试', 'hint_map_failed_load'));
      }
    });
    // 移除组件时注销
    return function () {
      // 设置上一页标题
      handleTitle(prevTitle);
      // 移除实例化对象
      mapInstance.destroy();
    };
  }, []); // eslint-disable-line

  // 隐藏时, 移除标注
  // useEffect(() => {
  //   if (show === false) {
  //     mapInstance.destroy();
  //   }
  // }, [show])

  // 初始化地图
  function initData() {
    if (!window.BMap) {
      // 如果有高德地图, 则加上 || !window.AMap
      setErrMsg(locale('地图库加载失败, 请稍后再试', 'hint_map_failed_load'));
      return;
    }
    console.log('初始化地图' + center);
    if (!refWrapperEl.current) {
      setErrMsg(locale('地图容器不存在', 'hint_map_no_container'));
      return;
    }
    mapInstance = new MapInstance();
    setMapInstance(mapInstance);
    mapInstance.initMap(refWrapperEl.current, center, function (result) {
      if (typeof result === 'string') {
        setErrMsg(result);
        return;
      }
    });
  }

  // 绘制标记点
  useEffect(function () {
    if (points && points.length && show && mapInstance) {
      console.log('绘制标记');
      console.log(mapInstance);
      mapInstance.drawMarkers(points);
    }
  }, [points]); // eslint-disable-line

  // 绘制圆形
  useEffect(function () {
    if (circle && circle.point && show) {
      console.log('绘制圆形');
      mapInstance.drawCircle(circle.point, circle.radius);
    }
  }, [circle]); // eslint-disable-line

  // 绘制多边形
  useEffect(function () {
    if (polygon && show) {
      console.log('绘制多边形');
      mapInstance.drawPolygon(polygon);
    }
  }, [polygon]); // eslint-disable-line

  // 绘制地区
  useEffect(function () {
    if (district && show) {
      console.log('绘制区域');
      var districtName = [];
      for (var name in district) {
        districtName.push(district[name].name);
      }
      mapInstance.drawDistrict(districtName.join(','));
    }
  }, [district]); // eslint-disable-line

  // 显隐
  useEffect(function () {
    if (show) {
      handleTitle(title);
    } else {
      handleTitle(prevTitle);
    }
    // eslint-disable-next-line
  }, [show]);

  // 中断绘制
  useEffect(function () {
    if (show) {
      if (errMsg) {
        mapInstance.abort = true;
      } else {
        mapInstance.abort = false;
      }
    }
    // eslint-disable-next-line
  }, [errMsg]);

  // 设置标题
  function handleTitle(title) {
    if (!title) return;
    if (typeof title === 'string') {
      Bridge.setTitle({
        title: title
      });
    } else if (typeof title === 'function') {
      title();
    }
  }
  var DOM = /*#__PURE__*/_jsxs(Page, _objectSpread(_objectSpread({}, others), {}, {
    className: (show ? '' : 'hide') + (others !== null && others !== void 0 && others.className ? ' ' + others.className : ''),
    children: [header && /*#__PURE__*/_jsx(Header, {
      children: header
    }), /*#__PURE__*/_jsxs(Container, {
      children: [/*#__PURE__*/_jsx(Wrapper, {
        ref: refWrapperEl
      }), onHide && /*#__PURE__*/_jsx(Close, {
        onClick: onHide
      }), children]
    }), errMsg && /*#__PURE__*/_jsx(Notice, {
      caption: errMsg
    })]
  }));
  if (portal) {
    return /*#__PURE__*/createPortal(DOM, portal);
  }
  return DOM;
}
export default MapView;