function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
var _excluded = ["portal", "animation", "sourceDOM", "offset", "visible", "maskClosable", "onVisibleChange", "maskProps", "children"];
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React, { useImperativeHandle, useRef, forwardRef, useEffect } from 'react';
import { createPortal } from 'react-dom';
import TooltipUtils from "./../Tooltip/Utils";
import { jsx as _jsx } from "react/jsx-runtime";
var Modal = /*#__PURE__*/forwardRef(function (_ref, ref) {
  var _maskProps4;
  var portal = _ref.portal,
    _ref$animation = _ref.animation,
    animation = _ref$animation === void 0 ? 'zoom' : _ref$animation,
    _ref$sourceDOM = _ref.sourceDOM,
    sourceDOM = _ref$sourceDOM === void 0 ? null : _ref$sourceDOM,
    _ref$offset = _ref.offset,
    offset = _ref$offset === void 0 ? null : _ref$offset,
    visible = _ref.visible,
    _ref$maskClosable = _ref.maskClosable,
    maskClosable = _ref$maskClosable === void 0 ? true : _ref$maskClosable,
    onVisibleChange = _ref.onVisibleChange,
    _ref$maskProps = _ref.maskProps,
    maskProps = _ref$maskProps === void 0 ? {} : _ref$maskProps,
    children = _ref.children,
    props = _objectWithoutProperties(_ref, _excluded);
  // 增加保护
  // eslint-disable-next-line
  if (!maskProps) maskProps = {};
  var rootRef = useRef(null);
  useImperativeHandle(ref, function () {
    return {
      rootDOM: rootRef.current,
      getRootDOM: function getRootDOM() {
        return rootRef.current;
      }
    };
  });
  useEffect(function () {
    // 更新模态框位置对齐目标元素
    updateModalPosition();
    // eslint-disable-next-line
  }, [visible]);

  // 受控显隐时, 需要更新容器位置
  function updateModalPosition() {
    var _maskProps, _maskProps$style, _maskProps2, _maskProps2$style;
    var maskDOM = rootRef === null || rootRef === void 0 ? void 0 : rootRef.current;
    // eslint-disable-next-line
    if (typeof sourceDOM === 'function') sourceDOM = sourceDOM();
    if (!sourceDOM || !maskDOM) return;
    if (visible && sourceDOM && maskDOM && !((_maskProps = maskProps) !== null && _maskProps !== void 0 && (_maskProps$style = _maskProps.style) !== null && _maskProps$style !== void 0 && _maskProps$style.top) && !((_maskProps2 = maskProps) !== null && _maskProps2 !== void 0 && (_maskProps2$style = _maskProps2.style) !== null && _maskProps2$style !== void 0 && _maskProps2$style.bottom)) {
      TooltipUtils.updateContainerPosition({
        source: sourceDOM,
        target: maskDOM,
        animation: animation,
        offset: offset
      });
    }
  }

  // 构建动画
  var position = TooltipUtils.getAnimationPosition(animation);

  // 点击遮罩
  function handleMaskClick(e) {
    var _maskProps3;
    if ((_maskProps3 = maskProps) !== null && _maskProps3 !== void 0 && _maskProps3.onClick) maskProps.onClick(e);
    if (maskClosable && onVisibleChange) onVisibleChange(false);
    e.stopPropagation();
  }

  // 点击模态框
  function handleModalClick(e) {
    e.stopPropagation();
  }

  // 获取激活状态样式
  function getActiveClass() {
    return visible ? ' active' : '';
  }
  var ModalNode = /*#__PURE__*/_jsx("div", _objectSpread(_objectSpread({}, maskProps), {}, {
    className: "mask modal-mask".concat((_maskProps4 = maskProps) !== null && _maskProps4 !== void 0 && _maskProps4.className ? ' ' + maskProps.className : '').concat(getActiveClass()),
    onClick: handleMaskClick,
    ref: rootRef,
    children: /*#__PURE__*/_jsx("div", _objectSpread(_objectSpread({}, props), {}, {
      className: "popup-animation modal".concat(position ? ' ' + position : '').concat(props.className ? ' ' + props.className : '').concat(getActiveClass()),
      "data-animation": animation,
      onClick: handleModalClick,
      children: children
    }))
  }));
  if (portal === null || portal === false) {
    return ModalNode;
  }
  return /*#__PURE__*/createPortal(ModalNode, portal || document.getElementById('root') || document.body);
});
export default Modal;