function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
var _excluded = ["visible", "value", "list", "multiple", "onSelect", "onBeforeChange", "onChange", "defaultPickerValue", "slotProps"];
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React, { forwardRef, useRef, useImperativeHandle, useEffect } from 'react';
import { formatList } from "./../../Select/utils";
import Instance from "./instance.js";
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
var Main = /*#__PURE__*/forwardRef(function (_ref, ref) {
  var visible = _ref.visible,
    value = _ref.value,
    list = _ref.list,
    multiple = _ref.multiple,
    onSelect = _ref.onSelect,
    onBeforeChange = _ref.onBeforeChange,
    onChange = _ref.onChange,
    defaultPickerValue = _ref.defaultPickerValue,
    slotProps = _ref.slotProps,
    props = _objectWithoutProperties(_ref, _excluded);
  // 过滤非法数据
  // eslint-disable-next-line
  list = formatList(list);

  // 节点
  var mainRef = useRef(null);
  var instance = useRef(null);
  useImperativeHandle(ref, function () {
    return {
      rootDOM: mainRef.current,
      getRootDOM: function getRootDOM() {
        return mainRef.current;
      },
      instance: instance.current,
      getInstance: function getInstance() {
        return instance.current;
      },
      getValue: getValue,
      update: update
    };
  });

  // useEffect(() => {
  //   initInstance()
  //   // eslint-disable-next-line
  // }, [])

  useEffect(function () {
    update();
    // eslint-disable-next-line
  }, [value]);

  // 更新句柄, 防止synchronization模式, 每次组件在render的时候都生成上次render的state、function、effects
  if (instance.current) {
    instance.current.params.onScrollTransitionEnd = handleChange;
  }

  // 更新视图
  function update() {
    if (instance.current) {
      if (list.length) {
        setDefault();
      }
    } else if (list && list.length > 0) {
      initInstance();
    }
  }

  // 设置默认选中项
  function setDefault() {
    var defaultOpt = getDefaultOption();
    if (!defaultOpt) return;
    instance.current.clearSlots();
    instance.current.addSlot(list, defaultOpt.id || '', (slotProps === null || slotProps === void 0 ? void 0 : slotProps.className) || 'text-center'); // 添加列,参数:数据,默认id,样式(lock样式为锁定列)
  }

  function getDefaultOption() {
    if (Array.isArray(value) && value.length) {
      return value[0];
    }
    if (list && list.length) {
      return list[0];
    }
    return null;
  }

  // 实例化
  function initInstance() {
    if (!list || !list.length || instance.current) {
      console.log('SeedsUI Picker: 参数list为空');
      return;
    }
    // render数据
    instance.current = new Instance({
      wrapper: mainRef.current,
      onScrollTransitionEnd: handleChange
    });
    // 默认项
    var defaultOpt = getDefaultOption();
    var id = '';
    if (defaultOpt && defaultOpt.id) id = defaultOpt.id;
    instance.current.addSlot(list, id, (slotProps === null || slotProps === void 0 ? void 0 : slotProps.className) || 'text-center');
    mainRef.current.instance = instance;
  }

  // 滚动结束
  function handleChange() {
    var newValue = getValue();
    onChange && onChange(newValue);
  }

  // 获取选中的值
  function getValue() {
    if (!instance.current) return;
    var newValue = instance.current.activeOptions;
    return newValue;
  }
  if (!Array.isArray(list) || !list.length) {
    return null;
  }
  return /*#__PURE__*/_jsxs("div", _objectSpread(_objectSpread({}, props), {}, {
    className: "picker-main".concat(props.className ? ' ' + props.className : ''),
    ref: mainRef,
    children: [/*#__PURE__*/_jsx("div", {
      className: "picker-layer",
      children: /*#__PURE__*/_jsx("div", {
        className: "picker-layer-frame"
      })
    }), /*#__PURE__*/_jsx("div", {
      className: "picker-slotbox"
    })]
  }));
});
export default Main;