function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0); } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i.return && (_r = _i.return(), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import React, { useImperativeHandle, useRef, forwardRef, useState } from 'react';
import locale from "./../../locale";
// 测试使用
// import { Button } from 'seedsui-react'
// 内库使用
import Button from "./../../Button";
import Preview from "./Preview";
import Modal from "./../Modal";

// Combo
import { jsx as _jsx } from "react/jsx-runtime";
import { Fragment as _Fragment } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
var Combo = function Combo(_ref, ref) {
  var value = _ref.value,
    onBeforeChange = _ref.onBeforeChange,
    onChange = _ref.onChange,
    portal = _ref.portal,
    color = _ref.color,
    backgroundColor = _ref.backgroundColor;
  var _useState = useState(false),
    _useState2 = _slicedToArray(_useState, 2),
    visible = _useState2[0],
    setVisible = _useState2[1];
  var comboRef = useRef(null);
  var modalRef = useRef(null);
  useImperativeHandle(ref, function () {
    var _comboRef$current, _modalRef$current, _modalRef$current2;
    return {
      rootDOM: comboRef !== null && comboRef !== void 0 && (_comboRef$current = comboRef.current) !== null && _comboRef$current !== void 0 && _comboRef$current.getRootDOM ? comboRef.current.getRootDOM() : comboRef.current,
      getRootDOM: function getRootDOM() {
        var _comboRef$current2;
        // div
        var rootDOM = comboRef === null || comboRef === void 0 ? void 0 : comboRef.current;
        // Input.Text
        if (comboRef !== null && comboRef !== void 0 && (_comboRef$current2 = comboRef.current) !== null && _comboRef$current2 !== void 0 && _comboRef$current2.getRootDOM) {
          rootDOM = comboRef.current.getRootDOM();
        }
        return rootDOM;
      },
      modalDOM: modalRef === null || modalRef === void 0 ? void 0 : (_modalRef$current = modalRef.current) === null || _modalRef$current === void 0 ? void 0 : _modalRef$current.rootDOM,
      getModalDOM: modalRef === null || modalRef === void 0 ? void 0 : (_modalRef$current2 = modalRef.current) === null || _modalRef$current2 === void 0 ? void 0 : _modalRef$current2.getRootDOM
    };
  });

  // 点击签名
  function handleSign() {
    setVisible(true);
  }

  // 修改签名
  function handleChange(base64) {
    setVisible(false);
    onChange === null || onChange === void 0 ? void 0 : onChange(base64);
  }
  // 已签显示图片
  if (value && typeof value === 'string') {
    return /*#__PURE__*/_jsx(Preview, {
      value: value,
      onDelete: onChange ? handleChange : null
    });
  }

  // 未签显示签名
  return /*#__PURE__*/_jsxs(_Fragment, {
    children: [/*#__PURE__*/_jsx(Button, {
      ref: comboRef,
      onClick: handleSign,
      children: locale('签名')
    }), /*#__PURE__*/_jsx(Modal, {
      ref: modalRef,
      portal: portal,
      visible: visible,
      value: value,
      onBeforeChange: onBeforeChange,
      onChange: handleChange,
      onVisibleChange: function onVisibleChange(newVisible) {
        setVisible(newVisible);
      }
      // 绘画配置
      ,
      color: color,
      backgroundColor: backgroundColor
    })]
  });
};
export default /*#__PURE__*/forwardRef(Combo);