import hide from "./hide";

// 显示Toast
// eslint-disable-next-line
function show(props) {
  // 更新属性
  function updateAttribute(mask) {
    if ((props === null || props === void 0 ? void 0 : props.maskClickable) === false) {
      mask.classList.remove('toast-propagation');
    } else {
      mask.classList.add('toast-propagation');
    }
  }

  // 渲染
  function render() {
    var toastId = '__SeedsUI_toast_el__';
    // 如果没生成成功, 则强制生成
    var mask = document.getElementById(toastId);
    if (!mask) {
      // 创建dom
      mask = document.createElement('div');
      mask.setAttribute('class', "mask toast-mask");
      mask.setAttribute('id', toastId);
      mask.innerHTML = "<div class=\"toast ".concat((props === null || props === void 0 ? void 0 : props.position) || 'middle', "\">\n        <div class=\"toast-wrapper\">\n          <div class=\"toast-content\">").concat((props === null || props === void 0 ? void 0 : props.content) || '', "</div>\n        </div>\n      </div>")
      // 添加到dom上
      ;
      (document.getElementById('root') || document.body).appendChild(mask);
    }

    // 更新toast属性
    updateAttribute(mask);

    // 显示
    mask.classList.add('active');
    mask.childNodes[0].classList.add('active');
    if (typeof (props === null || props === void 0 ? void 0 : props.onVisibleChange) === 'function') {
      props.onVisibleChange(true);
    }

    // 显示数秒后隐藏
    if (mask.showTimeout) window.clearTimeout(mask.showTimeout);
    if ((props === null || props === void 0 ? void 0 : props.duration) === false) return;
    mask.showTimeout = setTimeout(function () {
      hide();
      if (typeof (props === null || props === void 0 ? void 0 : props.onVisibleChange) === 'function') {
        props.onVisibleChange(false);
      }
    }, (props === null || props === void 0 ? void 0 : props.duration) || 2000);
  }
  render();
}
export default show;